Ptex: PtexIncrWriter Class Reference

Ptex

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
PtexIncrWriter Class Reference

`#include <PtexWriter.h>`

Inheritance diagram for PtexIncrWriter:

## Public Member Functions
| PtexIncrWriter (const char *path, FILE *fp, Ptex::MeshType mt, Ptex::DataType dt, int nchannels, int alphachan, int nfaces)
virtual bool | close (Ptex::String &error)
| Close the file. More...
virtual bool | writeFace (int faceid, const FaceInfo &f, const void *data, int stride)
| Write texture data for a face. More...
virtual bool | writeConstantFace (int faceid, const FaceInfo &f, const void *data)
| Write constant texture data for a face. More...
Public Member Functions inherited from PtexWriterBase
virtual void | setBorderModes (Ptex::BorderMode uBorderMode, Ptex::BorderMode vBorderMode)
| Set border modes. More...
virtual void | writeMeta (const char *key, const char *value)
| Write a string as meta data. More...
virtual void | writeMeta (const char *key, const int8_t *value, int count)
| Write an array of signed 8-bit integers as meta data. More...
virtual void | writeMeta (const char *key, const int16_t *value, int count)
| Write an array of signed 16-bit integers as meta data. More...
virtual void | writeMeta (const char *key, const int32_t *value, int count)
| Write an array of signed 32-bit integers as meta data. More...
virtual void | writeMeta (const char *key, const float *value, int count)
| Write an array of signed 32-bit floats as meta data. More...
virtual void | writeMeta (const char *key, const double *value, int count)
| Write an array of signed 32-bit doubles as meta data. More...
virtual void | writeMeta (PtexMetaData *data)
| Copy meta data from an existing meta data block. More...
virtual void | release ()
| Release resources held by this pointer (pointer becomes invalid). More...
bool | ok (Ptex::String &error)
void | getError (Ptex::String &error)

## Protected Member Functions
void | writeMetaDataEdit ()
virtual void | finish ()
virtual | ~PtexIncrWriter ()
Protected Member Functions inherited from PtexWriterBase
| PtexWriterBase (const char *path, Ptex::MeshType mt, Ptex::DataType dt, int nchannels, int alphachan, int nfaces, bool compress)
virtual | ~PtexWriterBase ()
int | writeBlank (FILE *fp, int size)
int | writeBlock (FILE *fp, const void *data, int size)
int | writeZipBlock (FILE *fp, const void *data, int size, bool finish=true)
int | readBlock (FILE *fp, void *data, int size)
int | copyBlock (FILE *dst, FILE *src, FilePos pos, int size)
Res | calcTileRes (Res faceres)
virtual void | addMetaData (const char *key, MetaDataType t, const void *value, int size)
void | writeConstFaceBlock (FILE *fp, const void *data, FaceDataHeader &fdh)
void | writeFaceBlock (FILE *fp, const void *data, int stride, Res res, FaceDataHeader &fdh)
void | writeFaceData (FILE *fp, const void *data, int stride, Res res, FaceDataHeader &fdh)
void | writeReduction (FILE *fp, const void *data, int stride, Res res)
int | writeMetaDataBlock (FILE *fp, MetaEntry &val)
void | setError (const std::string &error)
bool | storeFaceInfo (int faceid, FaceInfo &dest, const FaceInfo &src, int flags=0)
Protected Member Functions inherited from PtexWriter
virtual | ~PtexWriter ()
| Destructor not for public use. Use release() instead. More...

## Private Attributes
FILE * | _fp

## Additional Inherited Members
Public Types inherited from PtexIO
enum | Encoding { enc_constant, enc_zipped, enc_diffzipped, enc_tiled }
enum | EditType { et_editfacedata, et_editmetadata }
Public Types inherited from Ptex
enum | MeshType { mt_triangle, mt_quad }
| Type of base mesh for which the textures are defined. More...
enum | DataType { dt_uint8, dt_uint16, dt_half, dt_float }
| Type of data stored in texture file. More...
enum | BorderMode { m_clamp, m_black, m_periodic }
| How to handle mesh border when filtering. More...
enum | EdgeId { e_bottom, e_right, e_top, e_left }
| Edge IDs used in adjacency data in the Ptex::FaceInfo struct. More...
enum | MetaDataType { mdt_string, mdt_int8, mdt_int16, mdt_int32, mdt_float, mdt_double }
| Type of meta data entry. More...
Static Public Member Functions inherited from PtexWriter
static PtexWriter * | open (const char *path, Ptex::MeshType mt, Ptex::DataType dt, int nchannels, int alphachan, int nfaces, Ptex::String &error, bool genmipmaps=true)
| Open a new texture file for writing. More...
static PtexWriter * | edit (const char *path, bool incremental, Ptex::MeshType mt, Ptex::DataType dt, int nchannels, int alphachan, int nfaces, Ptex::String &error, bool genmipmaps=true)
| Open an existing texture file for writing. More...
static bool | applyEdits (const char *path, Ptex::String &error)
| Apply edits to a file. More...
Static Public Member Functions inherited from PtexIO
static bool | LittleEndian ()
Static Public Member Functions inherited from Ptex
static const char * | MeshTypeName (MeshType mt)
| Look up name of given mesh type. More...
static const char * | DataTypeName (DataType dt)
| Look up name of given data type. More...
static const char * | BorderModeName (BorderMode m)
| Look up name of given border mode. More...
static const char * | EdgeIdName (EdgeId eid)
| Look up name of given edge ID. More...
static const char * | MetaDataTypeName (MetaDataType mdt)
| Look up name of given meta data type. More...
static int | DataSize (DataType dt)
| Look up size of given data type (in bytes). More...
static float | OneValue (DataType dt)
| Look up value of given data type that corresponds to the normalized value of 1.0. More...
static float | OneValueInv (DataType dt)
| Lookup up inverse value of given data type that corresponds to the normalized value of 1.0. More...
static void | ConvertToFloat (float *dst, const void *src, Ptex::DataType dt, int numChannels)
| Convert a number of data values from the given data type to float. More...
static void | ConvertFromFloat (void *dst, const float *src, Ptex::DataType dt, int numChannels)
| Convert a number of data values from float to the given data type. More...
Static Public Attributes inherited from PtexIO
static const uint32_t | Magic = 'P' | ('t'<<8) | ('e'<<16) | ('x'<<24)
static const int | HeaderSize = sizeof(Header)
static const int | ExtHeaderSize = sizeof(ExtHeader)
static const int | LevelInfoSize = sizeof(LevelInfo)
static const int | FaceDataHeaderSize = sizeof(FaceDataHeader)
static const int | EditFaceDataHeaderSize = sizeof(EditFaceDataHeader)
static const int | EditMetaDataHeaderSize = sizeof(EditMetaDataHeader)
static const int | IBuffSize = 8192
static const int | BlockSize = 16384
static const int | TileSize = 65536
static const int | AllocaMax = 16384
static const int | MetaDataThreshold = 1024
Protected Attributes inherited from PtexWriterBase
bool | _ok
std::string | _error
std::string | _path
std::string | _tilepath
FILE * | _tilefp
Header | _header
ExtHeader | _extheader
int | _pixelSize
std::vector< MetaEntry > | _metadata
std::map< std::string, int > | _metamap
z_stream_s | _zstream
PtexUtils::ReduceFn * | _reduceFn

## Detailed Description

Definition at line 174 of file PtexWriter.h.

## Constructor & Destructor Documentation

PtexIncrWriter::PtexIncrWriter | ( | const char * | path,
|  | FILE * | fp,
|  | Ptex::MeshType | mt,
|  | Ptex::DataType | dt,
|  | int | nchannels,
|  | int | alphachan,
|  | int | nfaces
| ) |  |

Definition at line 1197 of file PtexWriter.cpp.

References PtexWriterBase::_extheader, _fp, PtexWriterBase::_header, PtexIO::Header::alphachan, PtexIO::Header::datatype, PtexIO::Header::extheadersize, PtexIO::ExtHeaderSize, PtexIO::HeaderSize, PtexIO::Header::magic, PtexIO::Magic, PtexIO::Header::meshtype, PtexUtils::min(), PtexIO::Header::nchannels, PtexIO::Header::nfaces, and PtexWriterBase::setError().

PtexIncrWriter::~PtexIncrWriter | ( |  | ) |
| protectedvirtual

Definition at line 1245 of file PtexWriter.cpp.

## Member Function Documentation

bool PtexIncrWriter::close | ( | Ptex::String & | error | ) |
| virtual

Close the file.

This operation can take some time if mipmaps are being generated or if there are many edit blocks. If an error occurs while writing, false is returned and an error string is written into the error parameter.

Reimplemented from PtexWriterBase.

Definition at line 1375 of file PtexWriter.cpp.

References _fp, and PtexWriterBase::close().

void PtexIncrWriter::finish | ( |  | ) |
| protectedvirtual

Implements PtexWriterBase.

Definition at line 1387 of file PtexWriter.cpp.

References PtexWriterBase::_extheader, _fp, PtexWriterBase::_header, PtexWriterBase::_metadata, PtexIO::ExtHeader::editdatapos, PtexIO::ExtHeader::editdatasize, PtexIO::Header::extheadersize, PtexIO::ExtHeaderSize, PtexIO::HeaderSize, PtexUtils::min(), and writeMetaDataEdit().

bool PtexIncrWriter::writeConstantFace | ( | int | faceid,
|  | const FaceInfo & | info,
|  | const void * | data
| ) |  |
| virtual

Write constant texture data for a face.

The data is written as a single constant texel value. Note: the resolution specified in the info param may indicate a resolution greater than 1x1 and the value will be preserved when reading. This is useful to indicate a texture's logical resolution even when the data is constant.

Implements PtexWriter.

Definition at line 1318 of file PtexWriter.cpp.

References _fp, PtexWriterBase::_pixelSize, PtexIO::enc_constant, PtexIO::et_editfacedata, PtexIO::EditFaceDataHeader::faceid, PtexIO::EditFaceDataHeader::faceinfo, PtexIO::EditFaceDataHeader::fdh, Ptex::FaceInfo::flag_constant, PtexIO::FaceDataHeader::set(), PtexWriterBase::storeFaceInfo(), and PtexWriterBase::writeBlock().

Referenced by writeFace().

bool PtexIncrWriter::writeFace | ( | int | faceid,
|  | const FaceInfo & | info,
|  | const void * | data,
|  | int | stride
| ) |  |
| virtual

Write texture data for a face.

The data is assumed to be channel-interleaved per texel and stored in v-major order.

Parameters

  faceid | Face index [0..nfaces-1].
  info | Face resolution and adjacency information.
  data | Texel data.
  stride | Distance between rows, in bytes (if zero, data is assumed packed).

If an error is encountered while writing, false is returned and an error message can be when close is called.

Implements PtexWriter.

Definition at line 1250 of file PtexWriter.cpp.

References _fp, PtexWriterBase::_header, PtexWriterBase::_pixelSize, PtexIO::Header::alphachan, PtexUtils::average(), PtexIO::FaceDataHeader::blocksize(), PtexUtils::copy(), PtexIO::Header::datatype, PtexUtils::divalpha(), PtexIO::et_editfacedata, PtexIO::EditFaceDataHeader::faceid, PtexIO::EditFaceDataHeader::faceinfo, PtexIO::EditFaceDataHeader::fdh, PtexIO::Header::hasAlpha(), PtexUtils::isConstant(), PtexUtils::multalpha(), PtexIO::Header::nchannels, Ptex::FaceInfo::res, Ptex::Res::size(), PtexWriterBase::storeFaceInfo(), Ptex::Res::u(), Ptex::Res::v(), PtexWriterBase::writeBlank(), PtexWriterBase::writeBlock(), writeConstantFace(), and PtexWriterBase::writeFaceData().

void PtexIncrWriter::writeMetaDataEdit | ( |  | ) |
| protected

Definition at line 1342 of file PtexWriter.cpp.

References _fp, PtexWriterBase::_metadata, PtexIO::et_editmetadata, PtexIO::EditMetaDataHeader::metadatamemsize, PtexIO::EditMetaDataHeader::metadatazipsize, PtexWriterBase::writeBlank(), PtexWriterBase::writeBlock(), PtexWriterBase::writeMetaDataBlock(), and PtexWriterBase::writeZipBlock().

Referenced by finish().

## Member Data Documentation

FILE* PtexIncrWriter::_fp
| private

Definition at line 190 of file PtexWriter.h.

Referenced by close(), finish(), PtexIncrWriter(), writeConstantFace(), writeFace(), and writeMetaDataEdit().

The documentation for this class was generated from the following files:

- PtexWriter.h
- PtexWriter.cpp